<?php

namespace Roberto\Roberto\Policies;

use Litepie\User\Contracts\UserPolicy;
use Roberto\Roberto\Models\2;

class 2Policy
{

    /**
     * Determine if the given user can view the 2.
     *
     * @param UserPolicy $user
     * @param 2 $2
     *
     * @return bool
     */
    public function view(UserPolicy $user, 2 $2)
    {
        if ($user->canDo('roberto.2.view') && $user->isAdmin()) {
            return true;
        }

        return $2->user_id == user_id() && $2->user_type == user_type();
    }

    /**
     * Determine if the given user can create a 2.
     *
     * @param UserPolicy $user
     * @param 2 $2
     *
     * @return bool
     */
    public function create(UserPolicy $user)
    {
        return  $user->canDo('roberto.2.create');
    }

    /**
     * Determine if the given user can update the given 2.
     *
     * @param UserPolicy $user
     * @param 2 $2
     *
     * @return bool
     */
    public function update(UserPolicy $user, 2 $2)
    {
        if ($user->canDo('roberto.2.edit') && $user->isAdmin()) {
            return true;
        }

        return $2->user_id == user_id() && $2->user_type == user_type();
    }

    /**
     * Determine if the given user can delete the given 2.
     *
     * @param UserPolicy $user
     * @param 2 $2
     *
     * @return bool
     */
    public function destroy(UserPolicy $user, 2 $2)
    {
        return $2->user_id == user_id() && $2->user_type == user_type();
    }

    /**
     * Determine if the given user can verify the given 2.
     *
     * @param UserPolicy $user
     * @param 2 $2
     *
     * @return bool
     */
    public function verify(UserPolicy $user, 2 $2)
    {
        if ($user->canDo('roberto.2.verify')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given 2.
     *
     * @param UserPolicy $user
     * @param 2 $2
     *
     * @return bool
     */
    public function approve(UserPolicy $user, 2 $2)
    {
        if ($user->canDo('roberto.2.approve')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperuser()) {
            return true;
        }
    }
}
